searchNodes=[{"doc":"Compiles a parser from a template.mix nimble_parsec.compile template.ex.exsThis task is useful to generate parsers that have no runtime dependency on NimbleParsec.ExamplesLet's define a template file:# lib/my_parser.ex.exs defmodule MyParser do @moduledoc false # parsec:MyParser import NimbleParsec date = integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) time = integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; optional(string(&quot;Z&quot;)) defparsec :datetime, date |&gt; ignore(string(&quot;T&quot;)) |&gt; concat(time) # parsec:MyParser endAfter running:mix nimble_parsec.compile lib/my_parser.ex.exsThe following file will be generated:# lib/my_parser.ex defmodule MyParser do @moduledoc false def datetime(binary, opts \\\\ []) do ... end defp datetime__0(...) do ... end ... endThe file will be automatically formatted if using Elixir v1.6+.Options-o - configures the output location. Defaults to the input file without its last extension","ref":"Mix.Tasks.NimbleParsec.Compile.html","title":"Mix.Tasks.NimbleParsec.Compile","type":"task"},{"doc":"NimbleParsec is a simple and fast library for text-based parser combinators.Combinators are built during runtime and compiled into multiple clauses with binary matching. This provides the following benefits:Performance: since it compiles to binary matching, it leverages many Erlang VM optimizations to generate extremely fast parser code with low memory usageComposable: this library does not rely on macros for building and composing parsers, therefore they are fully composable. The only macros are defparsec/3 and defparsecp/3 which emit the compiled clauses with binary matchingNo runtime dependency: after compilation, the generated parser clauses have no runtime dependency on NimbleParsec. This opens up the possibility to compile parsers and do not impose a dependency on users of your libraryNo footprints: NimbleParsec only needs to be imported in your modules. There is no need for use NimbleParsec, leaving no footprints on your modulesThe goal of this library is to focus on a set of primitives for writing efficient parser combinators. The composition aspect means you should be able to use those primitives to implement higher level combinators.Note this library does not handle low-level binary parsing. In such cases, we recommend using Elixir's bitstring syntax.Examplesdefmodule MyParser do import NimbleParsec date = integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) time = integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; optional(string(&quot;Z&quot;)) defparsec :datetime, date |&gt; ignore(string(&quot;T&quot;)) |&gt; concat(time), debug: true end MyParser.datetime(&quot;2010-04-17T14:12:34Z&quot;) #=&gt; {:ok, [2010, 4, 17, 14, 12, 34, &quot;Z&quot;], &quot;&quot;, %{}, 1, 21}If you add debug: true to defparsec/3, it will print the generated clauses, which are shown below:defp datetime__0(&lt;&lt;x0, x1, x2, x3, &quot;-&quot;, x4, x5, &quot;-&quot;, x6, x7, &quot;T&quot;, x8, x9, &quot;:&quot;, x10, x11, &quot;:&quot;, x12, x13, rest::binary&gt;&gt;, acc, stack, comb__context, comb__line, comb__column) when x0 &gt;= 48 and x0 &lt;= 57 and (x1 &gt;= 48 and x1 &lt;= 57) and (x2 &gt;= 48 and x2 &lt;= 57) and (x3 &gt;= 48 and x3 &lt;= 57) and (x4 &gt;= 48 and x4 &lt;= 57) and (x5 &gt;= 48 and x5 &lt;= 57) and (x6 &gt;= 48 and x6 &lt;= 57) and (x7 &gt;= 48 and x7 &lt;= 57) and (x8 &gt;= 48 and x8 &lt;= 57) and (x9 &gt;= 48 and x9 &lt;= 57) and (x10 &gt;= 48 and x10 &lt;= 57) and (x11 &gt;= 48 and x11 &lt;= 57) and (x12 &gt;= 48 and x12 &lt;= 57) and (x13 &gt;= 48 and x13 &lt;= 57) do datetime__1( rest, [(x13 - 48) * 1 + (x12 - 48) * 10, (x11 - 48) * 1 + (x10 - 48) * 10, (x9 - 48) * 1 + (x8 - 48) * 10, (x7 - 48) * 1 + (x6 - 48) * 10, (x5 - 48) * 1 + (x4 - 48) * 10, (x3 - 48) * 1 + (x2 - 48) * 10 + (x1 - 48) * 100 + (x0 - 48) * 1000] ++ acc, stack, comb__context, comb__line, comb__column + 19 ) end defp datetime__0(rest, acc, _stack, context, line, column) do {:error, &quot;...&quot;, rest, context, line, column} end defp datetime__1(&lt;&lt;&quot;Z&quot;, rest::binary&gt;&gt;, acc, stack, comb__context, comb__line, comb__column) do datetime__2(rest, [&quot;Z&quot;] ++ acc, stack, comb__context, comb__line, comb__column + 1) end defp datetime__1(rest, acc, stack, context, line, column) do datetime__2(rest, acc, stack, context, line, column) end defp datetime__2(rest, acc, _stack, context, line, column) do {:ok, acc, rest, context, line, column} endAs you can see, it generates highly inlined code, comparable to hand-written parsers. This gives NimbleParsec an order of magnitude performance gains compared to other parser combinators. Further performance can be gained by giving the inline: true option to defparsec/3.","ref":"NimbleParsec.html","title":"NimbleParsec","type":"module"},{"doc":"Defines a single ASCII codepoint in the given ranges.ranges is a list containing one of:a min..max range expressing supported codepointsa codepoint integer expressing a supported codepoint{:not, min..max} expressing not supported codepoints{:not, codepoint} expressing a not supported codepointExamplesdefmodule MyParser do import NimbleParsec defparsec :digit_and_lowercase, empty() |&gt; ascii_char([?0..?9]) |&gt; ascii_char([?a..?z]) end MyParser.digit_and_lowercase(&quot;1a&quot;) #=&gt; {:ok, [?1, ?a], &quot;&quot;, %{}, {1, 0}, 2} MyParser.digit_and_lowercase(&quot;a1&quot;) #=&gt; {:error, &quot;expected ASCII character in the range &#39;0&#39; to &#39;9&#39;, followed by ASCII character in the range &#39;a&#39; to &#39;z&#39;&quot;, &quot;a1&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#ascii_char/2","title":"NimbleParsec.ascii_char/2","type":"function"},{"doc":"Defines an ASCII string combinator with an exact length or min and max length.The ranges specify the allowed characters in the ASCII string. See ascii_char/2 for more information.If you want a string of unknown size, use ascii_string(ranges, min: 1). If you want a literal string, use string/2.Examplesdefmodule MyParser do import NimbleParsec defparsec :two_lowercase_letters, ascii_string([?a..?z], 2) end MyParser.two_lowercase_letters(&quot;abc&quot;) #=&gt; {:ok, [&quot;ab&quot;], &quot;c&quot;, %{}, {1, 0}, 2}","ref":"NimbleParsec.html#ascii_string/3","title":"NimbleParsec.ascii_string/3","type":"function"},{"doc":"Puts the result of the given combinator as the first element of a tuple with the byte_offset as second element.byte_offset is a non-negative integer.","ref":"NimbleParsec.html#byte_offset/2","title":"NimbleParsec.byte_offset/2","type":"function"},{"doc":"Chooses one of the given combinators.Expects at leasts two choices.Beware! Char combinatorsNote both utf8_char/2 and ascii_char/2 allow multiple ranges to be given. Therefore, instead this:choice([ ascii_char([?a..?z]), ascii_char([?A..?Z]), ])One should simply prefer:ascii_char([?a..?z, ?A..?Z])As the latter is compiled more efficiently by NimbleParsec.Beware! Always successful combinatorsIf a combinator that always succeeds is given as a choice, that choice will always succeed which may lead to unused function warnings since any further choice won't ever be attempted. For example, because repeat/2 always succeeds, the string/2 combinator below it won't ever run:choice([ repeat(ascii_char([?0..?9])), string(&quot;OK&quot;) ])Instead of repeat/2, you may want to use times/3 with the flags :min and :max.","ref":"NimbleParsec.html#choice/2","title":"NimbleParsec.choice/2","type":"function"},{"doc":"Concatenates two combinators.Examplesdefmodule MyParser do import NimbleParsec defparsec :digit_upper_lower_plus, concat( concat(ascii_char([?0..?9]), ascii_char([?A..?Z])), concat(ascii_char([?a..?z]), ascii_char([?+..?+])) ) end MyParser.digit_upper_lower_plus(&quot;1Az+&quot;) #=&gt; {:ok, [?1, ?A, ?z, ?+], &quot;&quot;, %{}, {1, 0}, 4}","ref":"NimbleParsec.html#concat/2","title":"NimbleParsec.concat/2","type":"function"},{"doc":"Inspects the combinator state given to to_debug with the given opts.","ref":"NimbleParsec.html#debug/2","title":"NimbleParsec.debug/2","type":"function"},{"doc":"Defines a combinator with the given name and opts.It is similar to defparsec/3 except it does not define an entry-point parsing function, just the combinator function to be used with parsec/2.","ref":"NimbleParsec.html#defcombinator/3","title":"NimbleParsec.defcombinator/3","type":"macro"},{"doc":"Defines a combinator with the given name and opts.It is similar to defparsecp/3 except it does not define an entry-point parsing function, just the combinator function to be used with parsec/2.","ref":"NimbleParsec.html#defcombinatorp/3","title":"NimbleParsec.defcombinatorp/3","type":"macro"},{"doc":"Defines a parser (and a combinator) with the given name and opts.The parser is a function that receives two arguments, the binary to be parsed and a set of options. You can consult the documentation of the generated parser function for more information.This function will also define a combinator that can be used as parsec(name) when building other parsers. See parsec/2 for more information on invoking compiled combinators.Beware!defparsec/3 is executed during compilation. This means you can't invoke a function defined in the same module. The following will error because the date function has not yet been defined:defmodule MyParser do import NimbleParsec def date do integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) end defparsec :date, date() endThis can be solved in different ways. You may simply compose a long parser using variables. For example:defmodule MyParser do import NimbleParsec date = integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) defparsec :date, date endAlternatively, you may define a Helpers module with many convenience combinators, and then invoke them in your parser module:defmodule MyParser.Helpers do import NimbleParsec def date do integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) end end defmodule MyParser do import NimbleParsec import MyParser.Helpers defparsec :date, date() endThe approach of using helper modules is the favorite way of composing parsers in NimbleParsec.Options:inline - when true, inlines clauses that work as redirection for other clauses. It is disabled by default because of a bug in Elixir v1.5 and v1.6 where unused functions that are inlined cause a compilation error:debug - when true, writes generated clauses to :stderr for debugging","ref":"NimbleParsec.html#defparsec/3","title":"NimbleParsec.defparsec/3","type":"macro"},{"doc":"Defines a private parser (and a combinator) with the given name and opts.The same as defparsec/3 but the parsing function is private.","ref":"NimbleParsec.html#defparsecp/3","title":"NimbleParsec.defparsecp/3","type":"macro"},{"doc":"Duplicates the combinator to_duplicate n times.","ref":"NimbleParsec.html#duplicate/3","title":"NimbleParsec.duplicate/3","type":"function"},{"doc":"Returns an empty combinator.An empty combinator cannot be compiled on its own.","ref":"NimbleParsec.html#empty/0","title":"NimbleParsec.empty/0","type":"function"},{"doc":"Defines an end of string combinator.The end of string does not produce a token and can be parsed multiple times. This function is useful to avoid having to check for an empty remainder after a successful parse.Examplesdefmodule MyParser do import NimbleParsec defparsec :letter_pairs, utf8_string([], 2) |&gt; repeat() |&gt; eos() end MyParser.letter_pairs(&quot;hi&quot;) #=&gt; {:ok, [&quot;hi&quot;], &quot;&quot;, %{}, {1, 0}, 2} MyParser.letter_pairs(&quot;hello&quot;) #=&gt; {:error, &quot;expected end of string&quot;, &quot;o&quot;, %{}, {1, 0}, 4}","ref":"NimbleParsec.html#eos/1","title":"NimbleParsec.eos/1","type":"function"},{"doc":"Marks the given combinator should appear eventually.Any other data before the combinator appears is discarded. If the combinator never appears, then it is an error.Examplesdefmodule MyParser do import NimbleParsec hour = integer(min: 1, max: 2) defparsec :extract_hour, eventually(hour) end MyParser.extract_hour(&quot;let&#39;s meet at 12?&quot;) #=&gt; {:ok, [12], &quot;?&quot;, %{}, {1, 0}, 16}","ref":"NimbleParsec.html#eventually/2","title":"NimbleParsec.eventually/2","type":"function"},{"doc":"Ignores the output of combinator given in to_ignore.Examplesdefmodule MyParser do import NimbleParsec defparsec :ignorable, string(&quot;T&quot;) |&gt; ignore() |&gt; integer(2, 2) end MyParser.ignorable(&quot;T12&quot;) #=&gt; {:ok, [12], &quot;&quot;, %{}, {1, 0}, 2}","ref":"NimbleParsec.html#ignore/2","title":"NimbleParsec.ignore/2","type":"function"},{"doc":"Defines an integer combinator with of exact length or min and max length.If you want an integer of unknown size, use integer(min: 1).This combinator does not parse the sign and is always on base 10.ExamplesWith exact length:defmodule MyParser do import NimbleParsec defparsec :two_digits_integer, integer(2) end MyParser.two_digits_integer(&quot;123&quot;) #=&gt; {:ok, [12], &quot;3&quot;, %{}, {1, 0}, 2} MyParser.two_digits_integer(&quot;1a3&quot;) #=&gt; {:error, &quot;expected ASCII character in the range &#39;0&#39; to &#39;9&#39;, followed by ASCII character in the range &#39;0&#39; to &#39;9&#39;&quot;, &quot;1a3&quot;, %{}, {1, 0}, 0}With min and max:defmodule MyParser do import NimbleParsec defparsec :two_digits_integer, integer(min: 2, max: 4) end MyParser.two_digits_integer(&quot;123&quot;) #=&gt; {:ok, [123], &quot;&quot;, %{}, {1, 0}, 2} MyParser.two_digits_integer(&quot;1a3&quot;) #=&gt; {:error, &quot;expected ASCII character in the range &#39;0&#39; to &#39;9&#39;, followed by ASCII character in the range &#39;0&#39; to &#39;9&#39;&quot;, &quot;1a3&quot;, %{}, {1, 0}, 0}If the size of the integer has a min and max close to each other, such as from 2 to 4 or from 1 to 2, using choice may emit more efficient code:choice([integer(4), integer(3), integer(2)])Note you should start from bigger to smaller.","ref":"NimbleParsec.html#integer/2","title":"NimbleParsec.integer/2","type":"function"},{"doc":"Adds a label to the combinator to be used in error reports.Examplesdefmodule MyParser do import NimbleParsec defparsec :digit_and_lowercase, empty() |&gt; ascii_char([?0..?9]) |&gt; ascii_char([?a..?z]) |&gt; label(&quot;digit followed by lowercase letter&quot;) end MyParser.digit_and_lowercase(&quot;1a&quot;) #=&gt; {:ok, [?1, ?a], &quot;&quot;, %{}, {1, 0}, 2} MyParser.digit_and_lowercase(&quot;a1&quot;) #=&gt; {:error, &quot;expected a digit followed by lowercase letter&quot;, &quot;a1&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#label/3","title":"NimbleParsec.label/3","type":"function"},{"doc":"Puts the result of the given combinator as the first element of a tuple with the line as second element.line is a tuple where the first element is the current line and the second element is the byte offset immediately after the newline.","ref":"NimbleParsec.html#line/2","title":"NimbleParsec.line/2","type":"function"},{"doc":"Checks if a combinator is ahead.If it succeeds, it continues as usual, otherwise it aborts the closest choice/2, repeat/2, etc. If there is no closest operation to abort, then it errors.Note a lookahead nevers changes the accumulated output nor the context.ExamplesFor example, imagine you want to parse a language that has the keywords &quot;if&quot; and &quot;while&quot; and identifiers made of any letters or number, where keywords and identifiers can be separated by a single white space:defmodule IfWhileLang do import NimbleParsec keyword = choice([ string(&quot;if&quot;) |&gt; replace(:if), string(&quot;while&quot;) |&gt; replace(:while) ]) identifier = ascii_string([?a..?z, ?A..?Z, ?0..?9], min: 1) defparsec :expr, repeat(choice([keyword, identifier]) |&gt; optional(string(&quot; &quot;))) endThe issue with the implementation above is that the following will parse:IfWhileLang.expr(&quot;iffy&quot;) {:ok, [:if, &quot;fy&quot;], &quot;&quot;, %{}, {1, 0}, 4}However, &quot;iffy&quot; should be treated as a full identifier. We could solve this by inverting the order of keyword and identifier in :expr but that means &quot;if&quot; itself will be considered an identifier and not a keyword. To solve this, we need lookaheads.One option is to check that after the keyword we either have an empty string OR the end of the string:keyword = choice([ string(&quot;if&quot;) |&gt; replace(:if), string(&quot;while&quot;) |&gt; replace(:while) ]) |&gt; lookahead(choice([string(&quot; &quot;), eos()]))However, in this case, a negative lookahead may be clearer, and we can assert that we don't have any identifier character after the keyword:keyword = choice([ string(&quot;if&quot;) |&gt; replace(:if), string(&quot;while&quot;) |&gt; replace(:while) ]) |&gt; lookahead_not(ascii_char([?a..?z, ?A..?Z, ?0..?9]))Now we get the desired result back:IfWhileLang.expr(&quot;iffy&quot;) #=&gt; {:ok, [&quot;iffy&quot;], &quot;&quot;, %{}, {1, 0}, 4} IfWhileLang.expr(&quot;if fy&quot;) #=&gt; {:ok, [:if, &quot; &quot;, &quot;fy&quot;], &quot;&quot;, %{}, {1, 0}, 5}","ref":"NimbleParsec.html#lookahead/2","title":"NimbleParsec.lookahead/2","type":"function"},{"doc":"Checks if a combinator is not ahead.If it succeeds, it aborts the closest choice/2, repeat/2, etc. Otherwise it continues as usual. If there is no closest operation to abort, then it errors.Note a lookahead nevers changes the accumulated output nor the context.For an example, see lookahead/2.","ref":"NimbleParsec.html#lookahead_not/2","title":"NimbleParsec.lookahead_not/2","type":"function"},{"doc":"Maps over the combinator results with the remote or local function in call.call is either a {module, function, args} representing a remote call, a {function, args} representing a local call or an atom function representing {function, []}.Each parser result will be invoked individually for the call. Each result be prepended to the given args. The args will be injected at the compile site and therefore must be escapable via Macro.escape/1.See post_traverse/3 for a low level version of this function.Examplesdefmodule MyParser do import NimbleParsec defparsec :letters_to_string_chars, ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; map({Integer, :to_string, []}) end MyParser.letters_to_string_chars(&quot;abc&quot;) #=&gt; {:ok, [&quot;97&quot;, &quot;98&quot;, &quot;99&quot;], &quot;&quot;, %{}, {1, 0}, 3}","ref":"NimbleParsec.html#map/3","title":"NimbleParsec.map/3","type":"function"},{"doc":"Marks the given combinator as optional.It is equivalent to choice([optional, empty()]).","ref":"NimbleParsec.html#optional/2","title":"NimbleParsec.optional/2","type":"function"},{"doc":"Invokes an already compiled combinator with name name in the same module.Every parser defined via defparsec/3 or defparsecp/3 can be used as combinators. However, the defparsec/3 and defparsecp/3 functions also define an entry-point parsing function, as implied by their names. If you want to define a combinator with the sole purpose of using it in combinator, use defcombinatorp/3 instead.Use casesparsec/2 is useful to implement recursive definitions.Note while parsec/2 can be used to compose smaller combinators, the favorite mechanism for doing composition is via regular functions and not via parsec/2. Let's see a practical example. Imagine that you have this module:defmodule MyParser do import NimbleParsec date = integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) time = integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; optional(string(&quot;Z&quot;)) defparsec :datetime, date |&gt; ignore(string(&quot;T&quot;)) |&gt; concat(time), debug: true endNow imagine that you want to break date and time apart into helper functions, as you use them in other occasions. Generally speaking, you should NOT do this:defmodule MyParser do import NimbleParsec defcombinatorp :date, integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) defcombinatorp :time, integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; optional(string(&quot;Z&quot;)) defparsec :datetime, parsec(:date) |&gt; ignore(string(&quot;T&quot;)) |&gt; concat(parsec(:time)) endThe reason why the above is not recommended is because each parsec/2 combinator ends-up adding a stacktrace entry during parsing, which affects the ability of NimbleParsec to optimize code. If the goal is to compose combinators, you can do so with modules and functions:defmodule MyParser.Helpers do import NimbleParsec def date do integer(4) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;-&quot;)) |&gt; integer(2) end def time do integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; ignore(string(&quot;:&quot;)) |&gt; integer(2) |&gt; optional(string(&quot;Z&quot;)) end end defmodule MyParser do import NimbleParsec import MyParser.Helpers defparsec :datetime, date() |&gt; ignore(string(&quot;T&quot;)) |&gt; concat(time()) endThe implementation above will be able to compile to the most efficient format as possible without forcing new stacktrace entries.The only situation where you should use parsec/2 for composition is when a large parser is used over and over again in a way compilation times are high. In this sense, you can use parsec/2 to improve compilation time at the cost of runtime performance. By using parsec/2, the tree size built at compile time will be reduced although runtime performance is degraded as every time this function is invoked it introduces a stacktrace entry.ExamplesA very limited but recursive XML parser could be written as follows:defmodule SimpleXML do import NimbleParsec tag = ascii_string([?a..?z, ?A..?Z], min: 1) text = ascii_string([not: ?&lt;], min: 1) opening_tag = ignore(string(&quot;&lt;&quot;)) |&gt; concat(tag) |&gt; ignore(string(&quot;&gt;&quot;)) closing_tag = ignore(string(&quot;&lt;/&quot;)) |&gt; concat(tag) |&gt; ignore(string(&quot;&gt;&quot;)) defparsec :xml, opening_tag |&gt; repeat(lookahead_not(string(&quot;&lt;/&quot;)) |&gt; choice([parsec(:xml), text])) |&gt; concat(closing_tag) |&gt; wrap() end SimpleXML.xml(&quot;&lt;foo&gt;bar&lt;/foo&gt;&quot;) #=&gt; {:ok, [[&quot;foo&quot;, &quot;bar&quot;, &quot;foo&quot;]], &quot;&quot;, %{}, {1, 0}, 14}In the example above, defparsec/3 has defined the entry-point parsing function as well as a combinator which we have invoked with parsec(:xml).In many cases, however, you want to define recursive combinators without the entry-point parsing function. We can do this by replacing defparsec/3 by defcombinatorp:defcombinatorp :xml, opening_tag |&gt; repeat(lookahead_not(string(&quot;&lt;/&quot;)) |&gt; choice([parsec(:xml), text])) |&gt; concat(closing_tag) |&gt; wrap()Note that now you can no longer invoke SimpleXML.xml(xml) as there is no associating parsing function. Eventually you will have to define a defparsec/3 or defparsecp/3, that invokes the combinator above via parsec/3.","ref":"NimbleParsec.html#parsec/2","title":"NimbleParsec.parsec/2","type":"function"},{"doc":"Traverses the combinator results with the remote or local function call.call is either a {module, function, args} representing a remote call, a {function, args} representing a local call or an atom function representing {function, []}.The function given in call will receive 5 additional arguments. The rest of the parsed binary, the parser results to be post_traversed, the parser context, the current line and the current offset will be prepended to the given args. The args will be injected at the compile site and therefore must be escapable via Macro.escape/1.The line and offset will represent the location after the combinators. To retrieve the position before the combinators, use pre_traverse/3.The call must return a tuple {acc, context} with list of results to be added to the accumulator as first argument and a context as second argument. It may also return {:error, reason} to stop processing. Notice the received results are in reverse order and must be returned in reverse order too.The number of elements returned does not need to be the same as the number of elements given.This is a low-level function for changing the parsed result. On top of this function, other functions are built, such as map/3 if you want to map over each individual element and not worry about ordering, reduce/3 to reduce all elements into a single one, replace/3 if you want to replace the parsed result by a single value and ignore/3 if you want to ignore the parsed result.Examplesdefmodule MyParser do import NimbleParsec defparsec :letters_to_chars, ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; post_traverse({:join_and_wrap, [&quot;-&quot;]}) defp join_and_wrap(_rest, args, context, _line, _offset, joiner) do {args |&gt; Enum.join(joiner) |&gt; List.wrap(), context} end end MyParser.letters_to_chars(&quot;abc&quot;) #=&gt; {:ok, [&quot;99-98-97&quot;], &quot;&quot;, %{}, {1, 0}, 3}","ref":"NimbleParsec.html#post_traverse/3","title":"NimbleParsec.post_traverse/3","type":"function"},{"doc":"The same as post_traverse/3 but receives the line and offset from before the wrapped combinators.post_traverse/3 should be preferred as it keeps less stack information. Use pre_traverse/3 only if you have to access the line and offset from before the given combinators.","ref":"NimbleParsec.html#pre_traverse/3","title":"NimbleParsec.pre_traverse/3","type":"function"},{"doc":"Invokes call to emit the AST that post_traverses the to_post_traverse combinator results.call is a {module, function, args} and it will receive 5 additional arguments. The AST representation of the rest of the parsed binary, the parser results, context, line and offset will be prepended to args. call is invoked at compile time and is useful in combinators that avoid injecting runtime dependencies.The line and offset will represent the location after the combinators. To retrieve the position before the combinators, use quoted_pre_traverse/3.The call must return a list of results to be added to the accumulator. Notice the received results are in reverse order and must be returned in reverse order too.The number of elements returned does not need to be the same as the number of elements given.This function must be used only when you want to emit code that has no runtime dependencies in other modules. In most cases, using post_traverse/3 is better, since it doesn't work on ASTs and instead works at runtime.","ref":"NimbleParsec.html#quoted_post_traverse/3","title":"NimbleParsec.quoted_post_traverse/3","type":"function"},{"doc":"The same as quoted_post_traverse/3 but receives the line and offset from before the wrapped combinators.quoted_post_traverse/3 should be preferred as it keeps less stack information. Use quoted_pre_traverse/3 only if you have to access the line and offset from before the given combinators.","ref":"NimbleParsec.html#quoted_pre_traverse/3","title":"NimbleParsec.quoted_pre_traverse/3","type":"function"},{"doc":"Invokes while to emit the AST that will repeat to_repeat while the AST code returns {:cont, context}.In case repetition should stop, while must return {:halt, context}.while is a {module, function, args} and it will receive 4 additional arguments. The AST representations of the binary to be parsed, context, line and offset will be prepended to args. while is invoked at compile time and is useful in combinators that avoid injecting runtime dependencies.","ref":"NimbleParsec.html#quoted_repeat_while/3","title":"NimbleParsec.quoted_repeat_while/3","type":"function"},{"doc":"Reduces over the combinator results with the remote or local function in call.call is either a {module, function, args} representing a remote call, a {function, args} representing a local call or an atom function representing {function, []}.The parser results to be reduced will be prepended to the given args. The args will be injected at the compile site and therefore must be escapable via Macro.escape/1.See post_traverse/3 for a low level version of this function.Examplesdefmodule MyParser do import NimbleParsec defparsec :letters_to_reduced_chars, ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; ascii_char([?a..?z]) |&gt; reduce({Enum, :join, [&quot;-&quot;]}) end MyParser.letters_to_reduced_chars(&quot;abc&quot;) #=&gt; {:ok, [&quot;97-98-99&quot;], &quot;&quot;, %{}, {1, 0}, 3}","ref":"NimbleParsec.html#reduce/3","title":"NimbleParsec.reduce/3","type":"function"},{"doc":"Allow the combinator given on to_repeat to appear zero or more times.Beware! Since repeat/2 allows zero entries, it cannot be used inside choice/2, because it will always succeed and may lead to unused function warnings since any further choice won't ever be attempted. For example, because repeat/2 always succeeds, the string/2 combinator below it won't ever run:choice([ repeat(ascii_char([?a..?z])), string(&quot;OK&quot;) ])Instead of repeat/2, you may want to use times/3 with the flags :min and :max.Also beware! If you attempt to repeat a combinator that can match nothing, like optional/2, repeat/2 will not terminate. For example, consider this combinator: repeat(optional(utf8_char([?a])))This combinator will never terminate because repeat/2 chooses the empty option of optional/2 every time. Since the goal of the parser above is to parse 0 or more ?a characters, it can be represented by repeat(utf8_char([?a])), because repeat/2 allows 0 or more matches.Examplesdefmodule MyParser do import NimbleParsec defparsec :repeat_lower, repeat(ascii_char([?a..?z])) end MyParser.repeat_lower(&quot;abcd&quot;) #=&gt; {:ok, [?a, ?b, ?c, ?d], &quot;&quot;, %{}, {1, 0}, 4} MyParser.repeat_lower(&quot;1234&quot;) #=&gt; {:ok, [], &quot;1234&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#repeat/2","title":"NimbleParsec.repeat/2","type":"function"},{"doc":"Repeats while the given remote or local function while returns {:cont, context}.If the combinator to_repeat stops matching, then the whole repeat loop stops successfully, hence it is important to assert the terminated value after repeating.In case repetition should stop, while must return {:halt, context}.while is either a {module, function, args} representing a remote call, a {function, args} representing a local call or an atom function representing {function, []}.The function given in while will receive 4 additional arguments. The rest of the binary to be parsed, the parser context, the current line and the current offset will be prepended to the given args. The args will be injected at the compile site and therefore must be escapable via Macro.escape/1.Examplesdefmodule MyParser do import NimbleParsec defparsec :string_with_quotes, ascii_char([?&quot;]) |&gt; repeat_while( choice([ ~S(\\&quot;) |&gt; string() |&gt; replace(?&quot;), utf8_char([]) ]), {:not_quote, []} ) |&gt; ascii_char([?&quot;]) |&gt; reduce({List, :to_string, []}) defp not_quote(&lt;&lt;?&quot;, _::binary&gt;&gt;, context, _, _), do: {:halt, context} defp not_quote(_, context, _, _), do: {:cont, context} end MyParser.string_with_quotes(~S(&quot;string with quotes \\&quot; inside&quot;)) {:ok, [&quot;\\&quot;string with quotes \\&quot; inside\\&quot;&quot;], &quot;&quot;, %{}, {1, 0}, 30}Note you can use lookahead/2 and lookahead_not/2 with repeat/2 (instead of repeat_while/3) to write a combinator that repeats while a combinator matches (or does not match). For example, the same combinator above could be written as:defmodule MyParser do import NimbleParsec defparsec :string_with_quotes, ascii_char([?&quot;]) |&gt; repeat( lookahead_not(ascii_char([?&quot;])) |&gt; choice([ ~S(\\&quot;) |&gt; string() |&gt; replace(?&quot;), utf8_char([]) ]) ) |&gt; reduce({List, :to_string, []}) end MyParser.string_with_quotes(~S(&quot;string with quotes \\&quot; inside&quot;)) {:ok, [&quot;\\&quot;string with quotes \\&quot; inside\\&quot;&quot;], &quot;&quot;, %{}, {1, 0}, 30}However, repeat_while is still useful when the condition to repeat comes from the context passed around.","ref":"NimbleParsec.html#repeat_while/3","title":"NimbleParsec.repeat_while/3","type":"function"},{"doc":"Replaces the output of combinator given in to_replace by a single value.The value will be injected at the compile site and therefore must be escapable via Macro.escape/1.Examplesdefmodule MyParser do import NimbleParsec defparsec :replaceable, string(&quot;T&quot;) |&gt; replace(&quot;OTHER&quot;) |&gt; integer(2, 2) end MyParser.replaceable(&quot;T12&quot;) #=&gt; {:ok, [&quot;OTHER&quot;, 12], &quot;&quot;, %{}, {1, 0}, 2}","ref":"NimbleParsec.html#replace/3","title":"NimbleParsec.replace/3","type":"function"},{"doc":"Defines a string binary value.Examplesdefmodule MyParser do import NimbleParsec defparsec :string_t, string(&quot;T&quot;) end MyParser.string_t(&quot;T&quot;) #=&gt; {:ok, [&quot;T&quot;], &quot;&quot;, %{}, {1, 0}, 1} MyParser.string_t(&quot;not T&quot;) #=&gt; {:error, &quot;expected a string \\&quot;T\\&quot;&quot;, &quot;not T&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#string/2","title":"NimbleParsec.string/2","type":"function"},{"doc":"Tags the result of the given combinator in to_tag in a tuple with tag as first element.Examplesdefmodule MyParser do import NimbleParsec defparsec :integer, integer(min: 1) |&gt; tag(:integer) end MyParser.integer(&quot;1234&quot;) #=&gt; {:ok, [integer: [1234]], &quot;&quot;, %{}, {1, 0}, 4}Notice, however, that the integer result is wrapped in a list, because the parser is expected to emit multiple tokens. When you are sure that only a single token is emitted, you should use unwrap_and_tag/3.","ref":"NimbleParsec.html#tag/3","title":"NimbleParsec.tag/3","type":"function"},{"doc":"Allow the combinator given on to_repeat to appear at least, at most or exactly a given amout of times.Examplesdefmodule MyParser do import NimbleParsec defparsec :minimum_lower, times(ascii_char([?a..?z]), min: 2) end MyParser.minimum_lower(&quot;abcd&quot;) #=&gt; {:ok, [?a, ?b, ?c, ?d], &quot;&quot;, %{}, {1, 0}, 4} MyParser.minimum_lower(&quot;ab12&quot;) #=&gt; {:ok, [?a, ?b], &quot;12&quot;, %{}, {1, 0}, 2} MyParser.minimum_lower(&quot;a123&quot;) #=&gt; {:ok, [], &quot;a123&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#times/3","title":"NimbleParsec.times/3","type":"function"},{"doc":"Unwraps and tags the result of the given combinator in to_tag in a tuple with tag as first element.Examplesdefmodule MyParser do import NimbleParsec defparsec :integer, integer(min: 1) |&gt; unwrap_and_tag(:integer) end MyParser.integer(&quot;1234&quot;) #=&gt; {:ok, [integer: 1234], &quot;&quot;, %{}, {1, 0}, 4}In case the combinator emits more than one token, an error will be raised. See tag/3 for more information.","ref":"NimbleParsec.html#unwrap_and_tag/3","title":"NimbleParsec.unwrap_and_tag/3","type":"function"},{"doc":"Defines a single UTF-8 codepoint in the given ranges.ranges is a list containing one of:a min..max range expressing supported codepointsa codepoint integer expressing a supported codepoint{:not, min..max} expressing not supported codepoints{:not, codepoint} expressing a not supported codepointExamplesdefmodule MyParser do import NimbleParsec defparsec :digit_and_utf8, empty() |&gt; utf8_char([?0..?9]) |&gt; utf8_char([]) end MyParser.digit_and_utf8(&quot;1é&quot;) #=&gt; {:ok, [?1, ?é], &quot;&quot;, %{}, {1, 0}, 2} MyParser.digit_and_utf8(&quot;a1&quot;) #=&gt; {:error, &quot;expected utf8 codepoint in the range &#39;0&#39; to &#39;9&#39;, followed by utf8 codepoint&quot;, &quot;a1&quot;, %{}, {1, 0}, 0}","ref":"NimbleParsec.html#utf8_char/2","title":"NimbleParsec.utf8_char/2","type":"function"},{"doc":"Defines an ASCII string combinator with of exact length or min and max codepoint length.The ranges specify the allowed characters in the ASCII string. See ascii_char/2 for more information.If you want a string of unknown size, use utf8_string(ranges, min: 1). If you want a literal string, use string/2.Examplesdefmodule MyParser do import NimbleParsec defparsec :two_letters, utf8_string([], 2) end MyParser.two_letters(&quot;áé&quot;) #=&gt; {:ok, [&quot;áé&quot;], &quot;&quot;, %{}, {1, 0}, 3}","ref":"NimbleParsec.html#utf8_string/3","title":"NimbleParsec.utf8_string/3","type":"function"},{"doc":"Wraps the results of the given combinator in to_wrap in a list.","ref":"NimbleParsec.html#wrap/2","title":"NimbleParsec.wrap/2","type":"function"},{"doc":"","ref":"NimbleParsec.html#t:bin_modifiers/0","title":"NimbleParsec.bin_modifiers/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:call/0","title":"NimbleParsec.call/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:exclusive_range/0","title":"NimbleParsec.exclusive_range/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:fargs/0","title":"NimbleParsec.fargs/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:inclusive_range/0","title":"NimbleParsec.inclusive_range/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:mfargs/0","title":"NimbleParsec.mfargs/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:min_and_max/0","title":"NimbleParsec.min_and_max/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:range/0","title":"NimbleParsec.range/0","type":"type"},{"doc":"","ref":"NimbleParsec.html#t:t/0","title":"NimbleParsec.t/0","type":"opaque"}]